/******************************************************************************\

                Copyright (c) 2013 Chris Burns & Warren Hunt
                            All rights reserved.

       Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:
   
   * Redistributions of source code must retain the above copyright notice,
     this list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.
   * Neither the name of the <organization> nor the
     names of its contributors may be used to endorse or promote products
     derived from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    DISCLAIMED. IN NO EVENT SHALL COPYRIGHT HOLDER BE LIABLE FOR ANY DIRECT,
 INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
    OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
              EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

      This code accompanies the Journal of Computer Graphics Techniques 
  (http://jcgt.org) article titled "The Visibility Buffer: A Cache-Friendly 
    Approach to Deferred Shading". These files were automatically generated 
                    by the system described in the article.

\******************************************************************************/

#define SAMPLES_PER_PIXEL    4
#define INSTANCE_ID_MASK     1023
#define INSTANCE_ID_BITS     10

struct __Output
{
   uint visibility : SV_Target0;
};

cbuffer __SystemConstants
{
   int InstanceID;  // starts at 1
};

__Output __VisibilityPixelShader
   ( in float4 screenPos : SV_Position
   , in uint pID         : SV_PrimitiveID)
{
   __Output o;
   o.visibility = (pID << INSTANCE_ID_BITS) | (InstanceID);
   return o;
}
